; Music Description Module for WhereIsIt?
; by Octavian Chis (a.k.a. TBD/FeR) (05.Dec.1999)
; e-mail: tbd@usa.net subj: [WhereIsIt?]
;
; purpose: add description for MOD, XM, iT, S3M, MT2 files
;          by reading their internal name
;  status: freeware with sources (ASM)
;   to do: - do some checks (open fail, memory alloc check)
;          - add more formats (easy)
;          - make it user-customizable
;
; WhereIsIt? (c) 1997-1999 Robert Galle http://www.whereisit-soft.com
;
; build with:
;  tasm32 -ml -m3 -q MusicModule
;  tlink32 /Tpd /aa /c MusicModule.obj, MusicModule.dll,, import32,MusicModule.def
;
; MusicModule.def
;   EXPORTS      ImportDesc_SameFile
;                RegisterDescPlugins
;                ModuleInfo

.386
.model flat,stdcall
.const

include DescAPI_ASM.inc                           ; WhereIsIt APi

DLL_PROCESS_DETACH  equ 0
DLL_PROCESS_ATTACH  equ 1
TRUE                equ 1

.data
extrn   _lclose     :PROC
extrn   _lopen      :PROC
extrn   _lread      :PROC
extrn   GlobalAlloc :PROC
extrn   GlobalFree  :PROC
extrn   lstrcpy     :PROC
extrn   MessageBoxA :PROC

GMEM_ZEROINIT   equ     0040h

hInsta          dd 0
MaskXM          db '*.xm',0
MaskIT          db '*.it',0
MaskMOD         db '*.mod',0
MaskMAD         db '*.mt2',0
MaskS3M         db '*.s3m',0
pReadMem        dd 0
szMaskXM        db 'Fast Tracker Files',0
szMaskS3M       db 'Scream Tracker Files',0
szMaskMOD       db 'Amiga Protracker Files',0
szMaskMAD       db 'Mad Tracker 2.0 Files',0
szAuthor        db 'Octavian Chis',0
szName          db 'Music Module',0
szMaskIT        db 'Impulse Tracker Files',0
szTitle         db 'About MusicModule.DLL',0
szVersion       db '1.2',0
szAbout         db 'Music Module 1.2',13,10
                db 'by Octavian Chis (a.k.a. TBD/FeR)',13,10
                db 'Date Build: 06.Dec.1999',0
MODTag          db 'M.K.'
S3MTag          db 'SCRM'
MADTag          db 'MT20'
XMTag           db 'Extended Module:'
iTTag           db 'IMPM'


public  ModuleInfo
public  RegisterDescPlugins
public  ImportDesc_SameFile

.code
DllEntry proc hInst: DWORD, reason:DWORD, reserved1:DWORD

    .if reason==DLL_PROCESS_ATTACH
        push hInst
        pop hInsta
    .endif
      mov  eax,TRUE
      ret

DllEntry Endp

ModuleInfo      proc ModuleName :DWORD, Author :DWORD, Version :DWORD

        call    lstrcpy, ModuleName, offset szName
        call    lstrcpy, Author, offset szAuthor
        call    lstrcpy, Version, offset szVersion
        ret

ModuleInfo      endp

RegisterDescPlugins proc AddrRegisterPlugin :DWORD

        call    AddrRegisterPlugin, 0, ptSameFile, offset szMaskMOD, \\
                offset MaskMOD, offset ConfigureProc
        call    AddrRegisterPlugin, 1, ptSameFile, offset szMaskXM, \\
                offset MaskXM, offset ConfigureProc
        call    AddrRegisterPlugin, 2, ptSameFile, offset szMaskIT, \\
                offset MaskIT, offset ConfigureProc
        call    AddrRegisterPlugin, 3, ptSameFile, offset szMaskS3M, \\
                offset MaskS3M, offset ConfigureProc
        call    AddrRegisterPlugin, 4, ptSameFile, offset szMaskMAD, \\
                offset MaskMAD, offset ConfigureProc
        ret

RegisterDescPlugins endp

ConfigureProc proc hInstance :DWORD, OwnerWnd :DWORD, PluginID : DWord

        call    MessageBoxA, OwnerWnd, offset szAbout, offset szTitle, 64
        ret

ConfigureProc endp

ImportDescription proc FileName :DWORD, DescResult :DWORD, \\
                       RequireFile :DWORD, IDOffset, IDSize, IDTag, SongNameOffset, SongNameSize :DWORD

        call    RequireFile, FileName
        mov     FileName, eax
        call    GlobalAlloc, GMEM_ZEROINIT, 4096      ; alloc 4096 bytes for read buffer
        mov     pReadMem, eax
        call    _lopen, FileName, 0
        push    eax                                   ; eax = file handle
        call    _lread, eax, pReadMem, 4096
        pop     eax
        call    _lclose, eax                          ; Close file
        mov     esi, pReadMem
        add     esi, IDOffset
        mov     edi, IDTag
        mov     ecx, IDSize
        rep     cmpsb
        jnz     error
        mov     esi, pReadMem
        add     esi, SongNameOffset
        mov     edi, DescResult
        mov     ecx, SongNameSize
        rep     movsb
        call    GlobalFree, pReadMem
        mov     eax, 1
        ret
error:
        mov     eax, 0
        ret

ImportDescription endp

ImportDesc_SameFile proc PluginID :WORD, FileName :DWORD, Desc: DWORD, RequireFile :DWORD

        .if PluginID == 0       ; MOD
                call    ImportDescription, FileName, Desc, RequireFile, 1080, 4, offset MODTag, 0, 20
        .elseif PluginID == 1   ; XM
                call    ImportDescription, FileName, Desc, RequireFile, 0, 16, offset XMTag, 17, 20
        .elseif PluginID == 2   ; iT
                call    ImportDescription, FileName, Desc, RequireFile, 0, 4, offset iTTag, 4, 26
        .elseif PluginID == 3   ; S3M
                call    ImportDescription, FileName, Desc, RequireFile, 44, 4, offset S3MTag, 0, 28
        .elseif PluginID == 4   ; MT2
                call    ImportDescription, FileName, Desc, RequireFile, 0, 4, offset MADTag, 42, 20
        .endif
        ret

ImportDesc_SameFile endp

End DllEntry
